// Utilizarea unui map ca sir de frecvente
// a unor obiecte

#include <vector>
#include <fstream> 
/* Se citesc notele unor copii astfel:
 * Pe fiecare linie: nume nota
 * Sa se afiseze toti copiii si numarul de note pe care 
 * le-a obtinut fiecare copil.

 */ 
#include <tuple>
#include <string>
#include <algorithm>
#include <set>
#include <map>
using namespace std;

struct Copil {
	
	bool operator < (Copil const& c) const noexcept
	{
		return nume < c.nume;
	}
	
	bool operator > (Copil const& c) const noexcept
	{
		return nume > c.nume;
	}
	string nume;
	int nota;
};

ifstream fin("copiii.in");
ofstream fout("copiii.out");

int main()
{
	//int fr[1000]; // fr[-12.34]++; = NU merge
	
	map<Copil, int, greater<Copil>> fr;
	string nume;
	int nota;
	while (fin >> nume >> nota)
		fr[{nume, nota}]++;
	
	
	for (auto p : fr)
		fout << p.first.nume << " " << p.second << '\n';
	
	fout << '\n';
	for (auto [copil, frecv] : fr)
			fout << copil.nume << ' ' << frecv << '\n';
	
}

