// Normalizarea unui sir numeric
/*
 *  110 25  70  33  44  110 25  33
     5   1   4   2   3    5  1  2 
 * 
 * 
 */ 
#include <vector>
#include <fstream> 
#include <tuple>
#include <string>
#include <algorithm>
#include <set>
#include <map>
using namespace std;


const int Dim = 10000;
int a[Dim]; // sirul care se da
int n;
int b[Dim]; // auxiliar
int k;      // nr de valori din b[] 
int c[Dim]; // pastreaza unicatele din sirul a[], in ordine crescatoare

ifstream fin("normalizare_sir.in");
ofstream fout("normalizare_sir.out");

int Cb(int v);

int main()
{
	fin >> n;
	for (int i = 1; i <= n; ++i)
	{
		fin >> a[i];
		b[i] = a[i];
	}
	
	// b[] = {110 25  70  33  44  110 25  33}
	// sortam sirul b;
	// b[] = {25 25 33 33 44 70 110 110 }
	//
	sort(b + 1, b + n + 1);                // O(n * log2(n))
	// eliminam dublurile din b[]
	
	// in c[] salvam unicatele din b[]
	c[++k] = b[1];
	
	for (int i = 2; i <= n; ++i)   
		if (b[i] != b[i - 1])
			c[++k] = b[i];
			
	//  acum c[] = {25 33 44 70 110}
	// 		         1  2  3  4  5
	 
	// cautam binar fiecare valoare a[i] in sirul c[]
	// si returnam pozitia (care va fi noua val a lui a[i]
	for (int i = 1; i <= n; ++i)       // O(n * log2(n))
		a[i] = Cb(a[i]);
		
	// sirul a[] normalizat:
	
	for (int i = 1; i <= n; ++i)
		fout << a[i] << ' ';
		
	return 0;
}

int Cb(int v)
{
	int st = 1, dr = k, m;
	while (st <= dr)
	{
		m = (st + dr) / 2;
		if (c[m] == v)
			return m;
		if (v > c[m])
			st = m + 1;
		else
			dr = m - 1;
	}
	
	return -1;
}




